<?php
/*
Plugin Name:ゆずまるの make_child_theme
Plugin URI:http://yuzumaru.info
Description:現在のテーマの子テーマを作ります。作ったらこのプラグインは捨ててね。間違うと上書きしちゃうから。
Version:1.81116
Author:CamCam custom yuzumaru
Author URI:http://yuzumaru.info
*/
/********************************************************/
function make_child_theme_ver()
/********************************************************/
{
	// ------------------------
	// [ version 表記 ]
	// ------------------------
	return "1.81116";
}
/********************************************************/
function make_child_theme_tracesub($buf,$sw)
/********************************************************/
{
	// フォルダー名
	$myfolder ="make_child_theme";
	//
	// trace stop
	$trace_stop = 1;	// 0:trace run 1;trace stop
	//
	// make_child_theme_tracesub("----","w");	// first trace
	// make_child_theme_tracesub("data","a+");	// continue trace
	//
	if($trace_stop==0){
		$file = WP_PLUGIN_DIR."/".$myfolder."/snap.txt";
		$fp = fopen($file, $sw); 
		fwrite($fp, "$buf\n");
		fclose($fp); 
	}
}
/********************************************************/
// WP設定画面設定
/********************************************************/
add_action('admin_menu' , 'make_child_theme_control');			// WP設定画面に追加
/********************************************************/
function make_child_theme_control()
/********************************************************/
{
	add_options_page(
		'ゆずまるの子テーマ作成',		// 1.設定画面での見出し
		'ゆずまるの子テーマ作成',		// 2.設定->メニューでの名前
		'administrator',				// 3.アクセスレベル
		__FILE__,						// 4.決まり文句
		'make_child_theme_entry'		// 5.設定の本体関数名
	);

}
/********************************************************/
function make_child_theme_entry()
/********************************************************/
{

	echo "<h2>ゆずまるの make_child_theme_ ver ".make_child_theme_ver().".</h2>";
	//----------------------------------------------------
	// デフォルト
	//----------------------------------------------------
	$from_path = get_template_directory();
	$make_path = $from_path;
	$pos = mb_strrpos($make_path,'/');
	if($pos!==false){
		$make_path = substr($make_path,0,$pos);
	}
	$from_name = get_template();
	$make_name = $from_name.'_child';
	$myfolders = WP_PLUGIN_DIR.'/make_child_theme';
	//----------------------------------------------------
	// 保存
	//----------------------------------------------------
	$act = 'no';
	$exe = '';
	if( isset($_POST['action']) ){
		if( $_POST['make_child_theme_env'] !='' ){
			$act = 'GO';
			$exe = make_child_theme_execute($myfolders,$from_path,$from_name,$make_path,$make_name,get_template());
		}
	}
	$make_child_theme_env = get_option('make_child_theme_env');
?>
<form method="post" action="">
	<input type="checkbox" name="make_child_theme_env" id="make_child_theme_env" value="checked" <?php echo $make_child_theme_env; ?>>
	<?php echo get_template(); ?> の 子テーマを <br />
	<?php echo $make_path; ?> に <br />
	<?php echo $make_name; ?> という名前で作ります。<br />
<?php
	$debug = '';
	if($debug != '' ){
?>
<br />
	<?php echo $from_path; ?><br />
	<?php echo $from_name; ?><br />
	<?php echo $myfolders; ?><br />
<br />
	<?php echo $act; ?><br />
	<?php echo $exe; ?><br />
<?php
	}
?>
	<p class="submit">
	<input type="submit" class="button-primary" name="action" value="<?php _e('Save Changes') ?>" />
	<input type="hidden" name="action" value="update" />
	</p>
</form>
<?php
}
/********************************************************/
function make_child_theme_execute($myfolders,$from_path,$from_name,$make_path,$make_name,$papa_name)
/********************************************************/
{
	//make_folder
	$cmd_line = '';

	$cmd_line.= '/usr/bin/perl ';
	$cmd_line.= $myfolders.'/';
	$cmd_line.= 'system_cmd.cgi ';
	$cmd_line.= 'pass='.'yuzumaru ';
	$cmd_line.= 'mode='.'mkdir ';
	$cmd_line.= 'path='.$make_path.'/'.$make_name.' ';
	$cmd_line.= 'cmod='.' ';
	//$cmd_line.= 'trce='.$myfolders.'/';
	$stat = exec($cmd_line);
	
	$cmd_line.= '/usr/bin/perl ';
	$cmd_line.= $myfolders.'/';
	$cmd_line.= 'system_cmd.cgi ';
	$cmd_line.= 'pass='.'yuzumaru ';
	$cmd_line.= 'mode='.'chmod ';
	$cmd_line.= 'path='.$make_path.'/'.$make_name.' ';
	$cmd_line.= 'cmod='.'755';
	//$cmd_line.= 'trce='.$myfolders.'/';
	$stat = exec($cmd_line);
	
	$path = $make_path.'/'.$make_name;
	
	$css_file = $path."/style.css";
	$fp = fopen($css_file, "w"); 
	fwrite($fp, "/*"."\n");
	fwrite($fp, " Theme Name:   ".$make_name."\n");
	fwrite($fp, " Template:     ".$papa_name."\n");
	fwrite($fp, "*/"."\n");
	fwrite($fp, "\n");
	fclose($fp); 
	
	$fnc_file = $path.'/function.php';
	copy($myfolders.'/function.php',$fnc_file);

	$thm_file = $path.'/screenshot.png';
	copy($from_path.'/screenshot.png',$thm_file);

	$cmd_line.= '/usr/bin/perl ';
	$cmd_line.= $myfolders.'/';
	$cmd_line.= 'system_cmd.cgi ';
	$cmd_line.= 'pass='.'yuzumaru ';
	$cmd_line.= 'mode='.'chmod ';
	$cmd_line.= 'path='.$css_file.' ';
	$cmd_line.= 'cmod='.'755';
	//$cmd_line.= 'trce='.$myfolders.'/';
	$stat = exec($cmd_line);

	$cmd_line.= '/usr/bin/perl ';
	$cmd_line.= $myfolders.'/';
	$cmd_line.= 'system_cmd.cgi ';
	$cmd_line.= 'pass='.'yuzumaru ';
	$cmd_line.= 'mode='.'chmod ';
	$cmd_line.= 'path='.$fnc_file.' ';
	$cmd_line.= 'cmod='.'755';
	//$cmd_line.= 'trce='.$myfolders.'/';
	$stat = exec($cmd_line);
	
	return($stat);
}
/********************************************************/
?>